"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var Subject_1 = require('rxjs/Subject');
var SimpleMQ = (function () {
    function SimpleMQ() {
        this.msgQueues = {};
    }
    SimpleMQ.prototype.getQueue = function () {
        return Object.keys(this.msgQueues);
    };
    SimpleMQ.prototype.newQueue = function (name) {
        if (this.msgQueues[name] === undefined) {
            var s = new Subject_1.Subject();
            var o = s.asObservable();
            this.msgQueues[name] = { 's': s, 'o': o };
        }
    };
    SimpleMQ.prototype.publish = function (name, msg, lazy) {
        if (lazy === void 0) { lazy = true; }
        if (lazy) {
            this.newQueue(name);
        }
        else if (!this.msgQueues[name]) {
            return false;
        }
        this.msgQueues[name]['s'].next(msg);
        return true;
    };
    SimpleMQ.prototype.subscribe = function (name, callback, lazy) {
        if (lazy === void 0) { lazy = true; }
        if (lazy) {
            this.newQueue(name);
        }
        else if (!this.msgQueues[name]) {
            return false;
        }
        this.msgQueues[name]['o'].subscribe(callback);
        return true;
    };
    SimpleMQ.prototype.log = function () {
        console.log(this.msgQueues);
    };
    SimpleMQ = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [])
    ], SimpleMQ);
    return SimpleMQ;
}());
exports.SimpleMQ = SimpleMQ;
//# sourceMappingURL=simple-mq.js.map